var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);
    }
};

app.initialize();

// Custom Stuff
//const website = "http://192.168.10.4/gtt/mobileapp/";
//const website = "http://track.gtt.co.tz/mobileapp/";
const website = "http://162.249.6.162/mobileapp/";
var appkey;

// Function to change null in json
function jsonnull(jval) {
    if (!jval) {
    	return "";
    } else {
    		return jval;
    }
}

$(document).ajaxStart(function() {
    $.mobile.loading('show');
});

$(document).ajaxStop(function() {
    $.mobile.loading('hide');
});

// Check connection type, wait seven hundred fifty milliseconds to initialize networkstate
setTimeout(function () {
	var networkState = navigator.connection.type;

	var states = {};
	states[Connection.UNKNOWN]  = 'Unknown connection';
	states[Connection.ETHERNET] = 'Ethernet connection';
	states[Connection.WIFI]     = 'WiFi connection';
	states[Connection.CELL_2G]  = 'Cell 2G connection';
	states[Connection.CELL_3G]  = 'Cell 3G connection';
	states[Connection.CELL_4G]  = 'Cell 4G connection';
	states[Connection.CELL]     = 'Cell generic connection';
	states[Connection.NONE]     = 'No network connection';
	
	if (states[networkState] == "Unknown connection" || states[networkState] == "Cell 2G connection" || states[networkState] == "No network connection") {
		alert('THE APP MIGHT NOT WORK WELL AS YOUR CONNECTION IS SLOW OR NOT AVAILABLE!');
	}
},750);

// Leaflet maps initializing and group of markers
var map = new L.map("map");
var lg = L.featureGroup().addTo(map);

$(document).on("pagecreate", function () {
	// Load Tile Layer
	L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {maxZoom: 18}).addTo(map);
	map.locate({setView: true, maxZoom: 18})
	// This tweak s used to avoid map tiles displaying randomly!
	setTimeout(function(){
		map.invalidateSize(true);
	}, 1);
})
$(document).ready(function () {
	// Perform appkey check
	checkKeyTable();	 

	// Disable head buttons until app verified	
	button_control(false, "reports,commands,appsettings,homebut,driverlist,maps");	
})

// Functions for details of trucks from main page
$(document).on("click", "li", function (e) {
	//alert(e.nodeType)
	// Apply only if clicking truck detail
	var id = $(this).prop("id");
	if(id && id.substr(0,9) == "truckdet_") {
		//alert(id)
		var detcontent = "";
		tid = id.substr(9);
		//alert(tid);
		$.ajax({
			url: website + 'truckdet.php',
			type: "GET",
			dataType: "json",
			data: {
				id: tid,							
			},
			success: function (data) {
				var glat, glong, currlocation, plateno;
				$.each(data, function (index,item) {
					glat = item.gdlatitude;
					glong = item.gdlongitude;
					plateno = item.plateno;
					fleetno = jsonnull(item.gdfleetno);
					currlocation = item.gdlocation;
					// Build page for details
					detcontent += "<h3>" + jsonnull(item.gdfleetno) + " " + item.plateno + "</h3>"
					if (item.gdleoparddescription) {
						detcontent += "<p><span style='font-weight: bold'>Description: <u>" + item.gdleoparddescription + "</u></span></p>";
					}
					detcontent += "<p>" + item.gdlocation + "</p>";
					detcontent += "<p>" + item.gdactualaddress + "</p>";
					detcontent += "<p><span style='text-decoration: underline; font-weight: bold'>Last Signal:</span> " + item.ts + "</span></p>";
					// Split by command and slash
					if(typeof item.gdextphoneno !== 'undefined' && item.gdextphoneno !== null){					
						var phones = item.gdextphoneno.split(/[,/]/);
						detcontent += "<p><span style='text-decoration: underline; font-weight: bold'>Driver:</span> " + item.gddrivername;
						for(p=0;p<phones.length;p++) {
							detcontent += "<a href='tel:" + phones[p] + "' data-role='button' data-icon='phone' class='ui-alt-icon'>" + " " + phones[p] + "</a>";
						}
					}
					// Show loaded info only if loaded!!
					if (item.gdactive == "t") {
						// First container always there
						detcontent += "<p><span style='text-decoration: underline; font-weight: bold'>Container 1:</span><br>" + item.ct1 + " (" + item.typ1 + ")<br>";
						detcontent += "For: " + item.o1 + "<br>";
						detcontent += "Cargo: " + item.c1 + "<br>Destination:" + item.dst1 + "</p>";
						// Send SMS to client buton
						//alert(item.osms1)
						if (item.osms1 != null) {
							detcontent += "<a data-role='button' data-icon='mail' id=smsbutton onclick=\"sendSms('Container " + item.ct1 + ' on truck ' + plateno + ' is currently ' + item.gdlocation + "','" + item.osms1 + "')\">SEND INFO SMS TO OWNER</a>"
						}
						if (item.ct2 != "NO CONTAINER SPECIFIED") {
							detcontent += "<span style='text-decoration: underline; font-weight: bold'>Container 2:</span><br>" + item.ct2 + " (" + item.typ2 + ")<br>";
							detcontent += "For: " + item.o2 + "<br>";
							detcontent += "Cargo: " + item.c2 + "<br><Destination:" + item.dst2 + "</p>";
							// Send SMS to client buton
							if (item.osms2 != null) {
								detcontent += "<a data-role='button' data-icon='mail' id=smsbutton onclick=\"sendSms('Container " + item.ct1 + ' on truck ' + plateno + ' is currently ' + item.gdlocation + "','" + item.osms2 + "')\">SEND INFO SMS TO OWNER</a>"
							}
						}
						if (item.ct3 != "NO CONTAINER SPECIFIED") {
							detcontent += "<span style='text-decoration: underline; font-weight: bold'>Container 3:</span><br>" + item.ct3 + " (" + item.typ3 + ")<br>";
							detcontent += "For: " + item.o3 + "<br>";
							detcontent += "Cargo: " + item.c3 + "<br>Destination: " + item.dst3 + "</p>";
							// Send SMS to client buton
							if (item.osms3 != null) {
								detcontent += "<a data-role='button' data-icon='mail' id=smsbutton onclick=\"sendSms('Container " + item.ct1 + ' on truck ' + plateno + ' is currently ' + item.gdlocation + "','" + item.osms3 + "')\">SEND INFO SMS TO OWNER</a>"
							}
						}	
					}
				});
				if (currlocation != "Location Network Error" && currlocation != "NOLOC") {
					detcontent += "<a data-role='button' onclick='showOnMap(" + glat + "," + glong + ",\"" + fleetno + " " + plateno + "\", false)'>SHOW VEHICLE ON MAP</a>"
				} else {
					detcontent += "<h2 style='color: red'>CANNOT DISPLAY - NO LOCATION</h2>";	
				}
				$("#maindet").html(detcontent).enhanceWithin();	
				$( ":mobile-pagecontainer" ).pagecontainer( "change", "#truckdet", { transition: "slide" } );
			}	
		})
	}
})

// One function to handle all events on page
document.addEventListener('touchstart', function (e) {
	// By Element ID
	switch(e.target.id) {
		// For settings -> Reset App Key
		case "resetapp":
			if (confirm('RESET APPLICATION KEY?')) {
				var db = window.openDatabase("localconfig", "1.0", "gtt_configuration", 200000);
				db.transaction(function (tx) {tx.executeSql('DROP TABLE key')}, function () { alert('ERROR IN RESETTING APPLICATION! PLEASE TRY AGAIN.') } , function () { window.location.href = "index.html" } );
			}
			break;
		case "menuappversion":
			cordova.getAppVersion(function (version) {
			    alert(version);
			});
			break;
		case "sendrep":
			// Send report
			$.ajax({
				url: website + 'sendreport.php',
				type: "GET",
				data: {
					customer: $("#selectrep").val(),	
				},
				success: function (data) {
					alert('REPORT SENT!');
				},
				error: function () {
					alert('ACTION FAILED, PLEASE RETRY. THERE COULD BE NO CONNECTIVITY!');
				},
				timeout: 5000
			});
			break;
		case "menucloseapp":
			$("#nav-panel").panel("close");
			navigator.app.exitApp();
			break;
		case "menuhomebut":	
			window.location.href = "index.html";
			//main_panel("active");	
			break;
		case "menudriverlist":
			$("#nav-panel").panel("close");
			var drivercontent = ""; 
			// extract driver list based on appkey
			$.ajax({
				url: website + 'driverlist.php',
				type: "GET",
				dataType: "json",
				data: {
					appkey: appkey,							
				},
				success: function (data) {
					if (data.length > 0) {
						drivercontent += "<ul data-role='listview' data-filter='true' data-filter-placeholder='Search Your Drivers..' data-inset='true' data-mini='true'>";
						$.each(data, function (index,item) {
							
							// Split by command and slash
							if(typeof item.gdextphoneno !== 'undefined' && item.gdextphoneno !== null){
								var phones = item.gdextphoneno.split(/[,/]/);
								for(p=0;p<phones.length;p++) {
									// Build Driver list with buttons to call them
									drivercontent += "<a data-role='button' data-icon='phone' href='tel: " + phones[p] + "'>";
									drivercontent += item.gddrivername + " " + item.plateno + "<br>" + phones[p];
									drivercontent += "</a>";
								}
							}
						});
						drivercontent += "</ul>";
						$("#detdriverlist").empty().html(drivercontent).enhanceWithin();	
						$( ":mobile-pagecontainer" ).pagecontainer( "change", "#drivers", { transition: "slide" } );
					}	
				},
				error: function () {
					alert('THERE HAS BEEN AN ERROR GATHERING DATA. PLEASE RETRY!');	
				}
			})
			break;
		case "menuappsettings":
			$("#nav-panel").panel("close");
			// Change page
			$( ":mobile-pagecontainer" ).pagecontainer( "change", "#settings", { transition: "slide" } );
			break;
		case "menumaps":
			showOnMap("","","",true);
			// Change page
			$( ":mobile-pagecontainer" ).pagecontainer( "change", "#map-page", { transition: "slide" } );
			break;
		case "menureports":
			$("#nav-panel").panel("close");
			button_control(true, "sendrep");
			// Load the select options
			//alert(appkey);
			$.ajax({
				url: website + 'loadedcustomersdropdown.php',
				type: "GET",
				dataType: "json",
				data: {
					appkey: appkey,							
				},
				success: function (data) {
					// Empty Select and restart
					$("#selectrep").empty();
					if (data.length > 0) {
						$.each(data, function(index,item) {
							//console.log("<option value=" + item.id + ">" + item.value + "</option>");
        					$("#selectrep").append("<option value='" + item.id + "'>" + item.value + "</option>"); 
						});
						// Change page
						$( ":mobile-pagecontainer" ).pagecontainer( "change", "#reports", { transition: "slide" } );
					} else {
						alert('YOU DO NOT HAVE CUSTOMERS TO SEND REPORTS!');	
						// Disable send button if no customers
						button_control(false, "sendrep");
					}
				},
				error: function (data) {
					alert('ERROR PROCESSING DATA. PLEASE RETRY!');		
				}
			})
			break;
		case "menucargo":
			var cargo = "";
			$("#nav-panel").panel("close");
			// Load cargo buttons
			$.ajax({
				url: website + 'cargo.php',
				type: "GET",
				dataType: "json",
				data: {
					appkey: appkey,							
				},
				success: function (data) {
					if (data.length > 0) {
						cargo += "<ul data-role='listview' data-filter='true' data-filter-placeholder='Search Your Cargo..' data-inset='true' data-mini='true'>";
						$.each(data, function(index,item) {
							cargo += "<li><a onclick=\"cargodet('" + item.c + "')\" data-icon='info'>" + item.c + "</a></li>"; 
						});
						cargo += "</ul>";
						$("#cargocontent").empty().html(cargo).enhanceWithin();	
						// Change page
						$( ":mobile-pagecontainer" ).pagecontainer( "change", "#cargo", { transition: "slide" } );
					} else {
						alert('YOU DO NOT HAVE ANY CARGO LOADED AT THE MOMENT!');
					}
				},
				error: function (data) {
					alert('ERROR PROCESSING DATA. PLEASE RETRY!');		
				}
			})
			break;
		case "menudestinations":
			var dest = "";
			$("#nav-panel").panel("close");
			// Load cargo buttons
			$.ajax({
				url: website + 'destinations.php',
				type: "GET",
				dataType: "json",
				data: {
					appkey: appkey,							
				},
				success: function (data) {
					if (data.length > 0) {
						dest += "<ul data-role='listview' data-inset='true' data-mini='true'>";
						$.each(data, function(index,item) {
							dest += "<li><a onclick=\"destdet('" + item.c + "')\" data-icon='info'>" + item.c + "</a></li>"; 
						});
						dest += "</ul>";
						$("#destinationcontent").empty().html(dest).enhanceWithin();	
						// Change page
						$( ":mobile-pagecontainer" ).pagecontainer( "change", "#destinations", { transition: "slide" } );
					} else {
						alert('NO DESTINATIONS SET AT THE MOMENT!');
					}
				},
				error: function (data) {
					alert('ERROR PROCESSING DATA. PLEASE RETRY!');		
				}
			})
			break;
		case "menucontainers":
			var cont = "";
			$("#nav-panel").panel("close");
			// Load cargo buttons
			$.ajax({
				url: website + 'containers.php',
				type: "GET",
				dataType: "json",
				data: {
					appkey: appkey,							
				},
				success: function (data) {
					if (data.length > 0) {
						//cont += "<ul data-role='listview' data-filter='true' data-filter-placeholder='Search Your Containers..' data-inset='true' data-mini='true'>";
						cont += "<div data-role='collapsibleset' data-filter='true' data-inset='true'>";
						$.each(data, function(index,item) {
							cont += "<div data-role='collapsible'>"
							cont += "<h4>" + item.c + " - " + item.ldescription + "</h4>";
							cont += "<ui data-role='listview'>";
							cont += "<li>On truck: " + jsonnull(item.gdfleetno) + " " + item.plateno + "<br><u>Loaded with:</u><br>" + item.cargo + "<br>Destination: " + item.dest + "<br>Owner: " + item.ldescription + "<br>Now " + item.gdlocation + "</li>";
							cont += "</ul></div>"; 
						});
						cont += "</div>";
						//cont += "</ul>";
						$("#containerscontent").empty().html(cont).enhanceWithin();	
						// Change page
						$( ":mobile-pagecontainer" ).pagecontainer( "change", "#containers", { transition: "slide" } );
					} else {
						alert('NO CONTAINERS LOADED AT THE MOMENT!');
					}
				},
				error: function (data) {
					alert('ERROR PROCESSING DATA. PLEASE RETRY!');		
				}
			})
			break;
	}
})

// Handle clicks on destination description. Show all truck for destination.
function destdet(det) {		
	var destdet = "";
	$.ajax({
		url: website + 'destinationsdet.php',
		type: "GET",
		dataType: "json",
		data: {
			destination: det,
			appkey: appkey			
		},
		success: function (data) {
			if (data.length > 0) {
				destdet += "<h4>" + det + "</h4>";
				destdet += "<ul data-role='listview' data-filter='true' data-inset='true'>";
				$.each(data, function(index,item) {
					//destdet += "<li>" + jsonnull(item.gdfleetno) + " " + item.plateno + "<br>Container: <span style='color: green; font-weight: bold'>" + item.cont + "</span><br><span style='color: red; text-decoration: underline'>Destination: " + item.dst + "</span><br>Owner: " + item.ldescription + "<br>" + item.gdlocation + "</li>";
					destdet += "<li>" + jsonnull(item.gdfleetno) + " " + item.plateno + "<br>Container: <span style='color: green; font-weight: bold'>" + item.cont + "</span><br>Owner: " + item.ldescription + "<br>" + item.gdlocation + "</li>"; 
				});
				destdet += "</ul>";
			} else {
				destdet += "NO CARGO IN THE SYSTEM";	
			}
			$("#destinationscontentdet").empty().html(destdet).enhanceWithin();	
			// Change page
			$( ":mobile-pagecontainer" ).pagecontainer( "change", "#destinationsdet", { transition: "slide" } );
		},
		error: function (xhr, ajaxOptions, thrownError) {
			alert('ERROR PROCESSING DATA. PLEASE RETRY!' + thrownError);		
		}
	})
}

// Handle clicks on cargo description. Show all truck info that carry this cargo.
function cargodet(det) {
	// Load cargo details based on cargo type. Simple list in cargocontentdet div				
	var cargodet = "";
	$.ajax({
		url: website + 'cargodet.php',
		type: "GET",
		dataType: "json",
		data: {
			cargo: det,
			appkey: appkey			
		},
		success: function (data) {
			if (data.length > 0) {
				cargodet += "<h4>" + det + "</h4>";
				cargodet += "<ul data-role='listview' data-inset='true'>";
				$.each(data, function(index,item) {
					cargodet += "<li>" + jsonnull(item.gdfleetno) + " " + item.plateno + "<br>Container: <span style='color: green; font-weight: bold'>" + item.cont + "</span><br>Destination: " + item.dst + "<br>" + item.gdlocation + "</li>"; 
				});
				cargodet += "</ul>";
				$("#cargocontentdet").empty().html(cargodet).enhanceWithin();	
				// Change page
				$( ":mobile-pagecontainer" ).pagecontainer( "change", "#cargodet", { transition: "slide" } );
			} else {
				cargodet += "NO CARGO IN THE SYSTEM";	
			}
		},
		error: function (xhr, ajaxOptions, thrownError) {
			alert('ERROR PROCESSING DATA. PLEASE RETRY!' + thrownError);		
		}
	})
}

function showOnMap(lat,lng,info,all) {
	// Remove all layers from featuregroup
	lg.clearLayers();
	// Check if we want single marker or all
	if (all == false) {
		L.marker([lat, lng]).bindPopup(info).addTo(lg);
		// Leaftlet tweak	
		setTimeout(function(){
			map.invalidateSize(true);
		}, 1);
		map.panTo([lat, lng]).setZoom(10);
	} else {
		// Remove all layers from featuregroup
		//lg.clearLayers();
		$.getJSON(website + 'truckmarkers.php?appkey=' + appkey, function(data) {
			// Create Layer of Markers
			$.each( data, function(i, m) {
				if (m.latitude !== null && m.longitude !== null) {
					L.marker([m.latitude, m.longitude]).bindPopup(jsonnull(m.gdfleetno) + " " + m.plateno + "<br>" + m.gddrivername + "<br>" + m.gdlocation).addTo(lg);
				}
			});
			setTimeout(function(){
				map.invalidateSize(true);
			}, 1);
			// resize and fit to bounds with padding
			map.fitBounds(lg.getBounds(), { padding: [25,25] });
		});
	}
	// Change page
	$( ":mobile-pagecontainer" ).pagecontainer( "change", "#map-page", { transition: "slide" } );
}

function sendSms(smstext,smsnumber) {
	// Disable button to avoid multiple sending
	$("#smsbutton").addClass("ui-disabled");
	// Send SMS through client phone
	//alert(smsnumber + " " + smstext)
	var messageInfo = {
   	phoneNumber: smsnumber,
   	textMessage: smstext
	}; 
	sms.sendMessage(messageInfo, function(message) {
	    //console.log("success: " + message);
	    alert('YOUR CUSTOMER HAS BEEN INFORMED!');
	    $("#smsbutton").removeClass("ui-disabled");
	}, function(error) {
	    console.log("code: " + error.code + ", message: " + error.message);
	    $("#smsbutton").removeClass("ui-disabled");
	});	
}

// Main panel display function
function main_panel(what) {
	// Resize left panel to fit under header
	// **************************************************** //
	var header = $('[data-role=header]').outerHeight(); 
	var panel = $('.ui-panel').height();
	var panelheight = panel - header;
	$('.ui-panel').css({
		'top': header,
		'min-height': panelheight
	});
	// **************************************************** //
	var pcontent;
	switch(what) {
		case "active":
			//alert('mpan' + appkey);
			// Enable buttons
			button_control(true, "reports,commands,appsettings,homebut,driverlist,maps");
			// Get all my trucks info and display on main page.
			pcontent = "<ul data-role='listview' data-filter='true' data-filter-placeholder='Search Your Trucks..' data-inset='true' data-mini='true'>";
			$.ajax({
				url: website + 'mytrucks.php',
				data: {
					appkey: window.appkey,
				},
				dataType: "json",
				success: function (data) {
					//alert(data);
					if (data != "false") {
						$.each(data, function(index,item) {
		     		 		pcontent += "<li id='truckdet_" + item.gdid + "'><a href='#'><p><span style='font-weight: bold; text-decoration: underline'>" + jsonnull(item.gdfleetno) + " " + item.plateno + " " + item.gdleoparddescription;
		     		 		if (item.gdactive == "t") {
		     		 			pcontent += " (CARRYING CARGO)";	
		     		 		} else {
		     		 				pcontent += " <span style='color: red'>(EMPTY)</span>";
		     		 		}
		     		 		pcontent += "</span><p>";
		     		 		pcontent += "<p>" + item.gdlocation + " <span style='margin-left: 2em'>(" + item.ts + ")</span></p>";
		     		 		pcontent += "<p>" + item.gdactualaddress + "</p>";
		     		 		switch(item.gdkeystatus) {
		     		 			case "131":
		     		 				pcontent += "<p>Key Status: ON"; 	
		     		 				break;
		     		 			case "195":
		     		 				pcontent += "<p>Key Status: OFF";
		     		 				break;
		     		 			case "137":
		     		 				pcontent += "<p>Key Status: <span style='color: red; text-decoration: underline'>ALARM</span>";
		     		 				break;	
		     		 			default:
		     		 				pcontent += "<p> --- ";
		     		 		}
		     		 		pcontent += "<span style='margin-left: 5em;'>Speed: " + item.gdspeed + " Km/h</span></p></a></li>";
		     		 	})
	     		 	} else {
	     		 		pcontent += "<li><h1>NO TRUCKS FOUND!</h1></li>";
	     		 	}
					
					pcontent += "</ul>";
					$("#main").html(pcontent).enhanceWithin();
				}
			})
			break;
		case "noactive":
			pcontent = "Application not activated!<br>\
			<a href='#' id='keyinsert' data-role='button' data-icon='alert'>Touch to insert activation key!</a>";
			$("#main").html(pcontent).enhanceWithin();
			// Add key request event listener here as we only need it when not active
			document.getElementById("keyinsert").addEventListener('touchstart', function (e) {
	   		checkKeyTable();
			});
			break;
	}
}

// Pull to refresh for main panel
$(function(){
	$('#wrap').xpull({
		'pullThreshold':50, // Pull threshold - amount in  pixels required to pull to enable release callback
		'callback':function(){
			main_panel("active");
		}, // triggers after user pulls the content over pull threshold and releases
		//'spinnerTimeout':2000 // timeout in miliseconds after which the loading indicator stops spinning. If set to 0 - the loading will be indefinite
	});		
});

// Check key on load, if does not exist then prompt for one abd create db table
// Check if config table exists in DB
var db = window.openDatabase("localconfig", "1.0", "gtt_configuration", 200000);
//db.transaction(function (tx) {tx.executeSql('DROP TABLE key')});

function button_control(enabled, which) {
	// enabled -> Button status
	// which -> csv list of buttons by ID (for fine control)
	var arrbtn = which.split(",");
	for(b = 0; b < arrbtn.length; b++) {
		if (enabled == true) {
			// Switch on
			$("#" + arrbtn[b]).removeClass("ui-disabled");	
		} else {
			// Swicth off
			$("#" + arrbtn[b]).addClass("ui-disabled");
		}		
	}	
}

function checkKeyTable() {
	db.transaction
	(
		function (tx)
			{
				tx.executeSql ('SELECT name FROM sqlite_master WHERE type="table" AND name="key"',[],
					function(tx,results) {
						var len = results.rows.length;
						if(len>0) {
							// Fetch appkey
							db.transaction(function (tx) {tx.executeSql('SELECT mykey from key', [] , function (tx, results) {  
									// Then add it to master var appkey for future use
									rs = results.rows.item(0);
									$.each(rs, function (key, val) {
										// Key is ok so add to global var
                					appkey = val;
                					main_panel("active");
            					});			
								}) 
							});
							
						} else {
							main_panel("noactive");
							// Prompt for key
							var thekey = prompt('PLEASE TYPE IN YOUR KEY!');
							if (thekey) {
								// Check against DB if it has been created
								$.ajax({
									url: website + 'keycheck.php',
									type: "GET",
									data: {
										key: thekey,	
									},
									success: function (data) {
										if (data != "") {
											var arrkey = data.split("*****");
											if (arrkey[0] == "OK") {
												// Create new key table and add key only if verified
												db.transaction(function (tx) {tx.executeSql('CREATE TABLE IF NOT EXISTS key (mykey TEXT)')}, errorCB, successCB);
												db.transaction(function (tx) {tx.executeSql('INSERT INTO key (mykey) VALUES ("' + arrkey[1] + '")')}, errorCB, successCB);
												alert('KEY VERIFIED');												
												appkey = arrkey[1];
												main_panel("active");
											} else {
												alert('THE KEY YOU HAVE ENTERED IS NOT VALID!');
											}
										} else {
											alert('YOU HAVE NOT BEEN ACTIVATED. PLEASE CALL GTT.');
										}
									},
									error: function () {
										alert('ACTION FAILED, PLEASE RETRY. THERE COULD BE NO CONNECTIVITY!');
									},
									timeout: 5000
								});
							}
						}
					}, errorCB
				);
		},errorCB,successCB
	);	
}

//function will be called when an error occurred
function errorCB(err) {
	alert("Error processing SQL: " + err.code);
}
 
//function will be called when process succeed
function successCB() {
	console.log("success!");
}